/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <http2>

#define PLUGIN "xRepo"
#define VERSION "1.0.0"
#define AUTHOR "Kia"

// ===============================================================================
// 	Variables
// ===============================================================================

// Flag required for using xRepo
#define XREPO_ACCESS ADMIN_BAN

// ===============================================================================
//    plugin_init()
// ===============================================================================

public plugin_init() 
{
	register_plugin( PLUGIN, VERSION, AUTHOR )
	
	/* Concmds */
	
	register_concmd("xrepo", "cmd_xrepo", XREPO_ACCESS)
	register_concmd("apt-get", "cmd_xrepo", XREPO_ACCESS)
	
	/* Tasks */
	
	GetRepos()
}

// ===============================================================================
// 	cmd_xrepo
// ===============================================================================

public cmd_xrepo(id, level, cid)
{	
	if (!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED
	
	new szCommand[64]
	
	read_argv(1, szCommand, charsmax(szCommand))
	
	if(equali(szCommand, "help"))
		cmd_help(id)
	else if(equali(szCommand, "list"))
		cmd_list(id)
	else if(equali(szCommand, "search"))
	{
		new szParam[64]
		read_argv(2, szParam, charsmax(szParam))
		SearchRepos(id, szParam, false)
	}
	else if(equali(szCommand, "install"))
	{
		new szParam[64]
		read_argv(2, szParam, charsmax(szParam))
		DownloadFromRepos(id, szParam)
	}
	else if(equali(szCommand, "update"))
		GetRepos()
	
	
	return PLUGIN_HANDLED
}


// ===============================================================================
// 	xrepo help(cmd_help) - Showing all available commands
// ===============================================================================

public cmd_help(id)
{
	server_print("(xrepo / apt-get) help : Shows all commands")
	server_print("(xrepo / apt-get) list : Lists all Repos from the .cfg file")
	server_print("(xrepo / apt-get) search <name> : Searchs for <name> in all repos.")
	server_print("(xrepo / apt-get) install <name> : Installs the package <name>.")
	server_print("(xrepo / apt-get) update  : Updates all repo files.")
	
	return PLUGIN_HANDLED
}

// ===============================================================================
// 	xrepo list (cmd_list) - Lists all Repos from the .cfg file
// ===============================================================================

public cmd_list(id)
{
	new szConfigDir[256], szRepoFile[256]
	
	get_configsdir(szConfigDir, charsmax(szConfigDir))
	formatex(szRepoFile, charsmax(szRepoFile),"%s/xRepo/repos.cfg", szConfigDir) 
	
	new sBuffer[256]
	
	new iFile = fopen(szRepoFile, "rt")
	if(!iFile)
	{
		server_print("[xRepo] Couldn't find %s.", szRepoFile)
		return
	}
	
	while(!feof(iFile))
	{
		fgets(iFile, sBuffer, charsmax(sBuffer))
		
		replace(sBuffer, charsmax(sBuffer), "^n", "")
			
		if((sBuffer[0] == ';' || !sBuffer[0]))
			continue

		server_print("%s", sBuffer)
	}
	
	fclose(iFile)
}

// ===============================================================================
//    Cmd_reporeload - Reloads the data from the repo file
// ===============================================================================

public Cmd_reporeload(id)
	GetRepos()

// ===============================================================================
//    GetRepos - Downloading all Repos
// ===============================================================================

public GetRepos( )
{
	new szConfigDir[256], szFile[256], szRepoDir[256], szRepoRepoDir[256]
	
	get_configsdir(szConfigDir, charsmax(szConfigDir))
	
	formatex(szRepoDir, charsmax(szRepoDir),"%s/xRepo", szConfigDir) 
	formatex(szRepoRepoDir, charsmax(szRepoRepoDir), "%s/repos", szRepoDir)
	formatex(szFile, charsmax(szFile),  "%s/repos.cfg", szRepoDir)
	
	if(!dir_exists(szRepoDir)) 
		mkdir(szRepoDir)
	
	if(!dir_exists(szRepoRepoDir))
		mkdir(szRepoRepoDir)
	
	if(!file_exists(szFile)) 
	{ 
		write_file(szFile, "")
	} 
	
	new szName[128], szURL[256], szWgetPath[256], sBuffer[256]
	
	new iFile = fopen(szFile, "rt")
	if(!iFile)
	{
		server_print("[xRepo] Couldn't find config file.")
		return
	}
	
	while(!feof(iFile))
	{
		fgets(iFile, sBuffer, charsmax(sBuffer))
		
		replace(sBuffer, charsmax(sBuffer), "^n", "")
			
		if((sBuffer[0] == ';' || !sBuffer[0]))
			continue
			
		parse(sBuffer, szName, charsmax(szName), szURL, charsmax(szURL))
		formatex(szWgetPath, charsmax(szWgetPath), "%s/%s.txt", szRepoRepoDir, szName)
		
		if(file_exists(szWgetPath))
		{
			delete_file(szWgetPath)
			server_print("[xRepo] Deleted %s since new version will be downloaded.", szWgetPath)
		}
		
		HTTP2_Download(szURL, szWgetPath, "wget_ReposDone")
	}
	
	fclose(iFile)
}

// ===============================================================================
// 	SearchRepos(id, szPlugin[])
// ===============================================================================

public SearchRepos(id, szPlugin[], bool:wget)
{
	new szConfigDir[256], szRepoDir[256]
	get_configsdir(szConfigDir, charsmax(szConfigDir))
	
	formatex(szRepoDir, charsmax(szRepoDir), "%s/xRepo/repos", szConfigDir)
	
	new szName[128], szDesc[128], szWget[128], szWgetName[128]
	new sBuffer[256]
	
	new szTempDir[128]
	
	new iFile
	new szFileName[64], szFileFull[128]
	
	new hDir = open_dir(szRepoDir, szFileName, charsmax(szFileName))
	
	new iCount = 0
	
	if(!hDir)
		return
		
	do
	{
		if(szFileName[0] == '.' || szFileName[1] == '.')
			continue
		
		formatex(szFileFull, charsmax(szFileFull), "%s/%s", szRepoDir, szFileName)
		iFile = fopen(szFileFull, "rt")
		
		if(!iFile)
		{
			server_print("[xRepo] Couldn't open %s!", szFileName)
			return
		}
		
		while(!feof(iFile))
		{
			fgets(iFile, sBuffer, charsmax(sBuffer))
			replace(sBuffer, charsmax(sBuffer), "^n", "")
			
			if((sBuffer[0] == ';' || !sBuffer[0]))
				continue
			
			if(wget)
			{
				get_configsdir(szTempDir, charsmax(szTempDir))
				formatex(szTempDir, charsmax(szTempDir), "%s/xRepo/temp", szTempDir)
				
				if(!dir_exists(szTempDir))
					mkdir(szTempDir)
				
				parse(sBuffer, szName, charsmax(szName), szDesc, charsmax(szDesc), szWget, charsmax(szWget) )
				
				if(equali(szName, szPlugin))
				{
					formatex(szWgetName, charsmax(szWgetName), "%s/%s.txt", szTempDir, szName)
					
					if(file_exists(szWgetName))
						delete_file(szWgetName)
					
					HTTP2_Download(szWget, szWgetName, "wget_PackageInfoDone")
				}
			}
			else
			{
				parse(sBuffer, szName, charsmax(szName), szDesc, charsmax(szDesc))
				if(containi(szName, szPlugin) != -1)
				{
					server_print("%s - %s", szName, szDesc)
					iCount++
				}
			}
		}
		
		fclose(iFile)
	}
	
	while ( next_file( hDir, szFileName, charsmax( szFileName ) ) )
	
	close_dir(hDir)
	
	if(!wget)
		if(iCount > 0)
			server_print("[xRepo] Found %i items matching your search.", iCount)
		else
			server_print("[xRepo] Couldn't find any items matching your search.")
	
}

// ===============================================================================
// 	DownloadFromRepos(id, szPlugin[])
// ===============================================================================

public DownloadFromRepos(id, szPlugin[])
{
	SearchRepos(id, szPlugin, true)
}

// ===============================================================================
// 	DownloadPackageContent(szPackageInfo[])
// ===============================================================================

public DownloadPackageContent(const szPackageInfo[])
{
	new iFile = fopen(szPackageInfo, "rt")
	new sBuffer[256]
	new szURL[128], szPath[128], szFolder[128]
	
	new i, iLen
	
	if(!iFile)
	{
		server_print("[xRepo] Couldn't open %s", szPackageInfo)
		return
	}
	
	while(!feof(iFile))
	{
		fgets(iFile, sBuffer, charsmax(sBuffer))
		replace(sBuffer, charsmax(sBuffer), "^n", "")
		
		if((sBuffer[0] == ';' || !sBuffer[0]))
			continue
		
		parse(sBuffer, szURL, charsmax(szURL), szPath, charsmax(szPath))
		
		formatex(szFolder, charsmax(szFolder), szPath)
		
		iLen = strlen( szFolder )
		
		for( i = iLen -1; i >= 0; i-- )
		{
			if( szFolder[ i ] == '/' || szFolder[ i ] == '\' )
			{
				szFolder[ i ] = EOS;
				break;
			}
		}
		
		if(!dir_exists(szFolder))
		{
			if(equali(szFolder, "gfx") || equali(szFolder, "maps") || equali(szFolder, "models") || equali(szFolder, "overviews") || equali(szFolder, "sound") || equali(szFolder, "sprites"))
				continue
			else
				mkdir(szFolder)
		}
		
		HTTP2_Download(szURL, szPath, "wget_PackageItemDone")
	}
	
	fclose(iFile)
	delete_file(szPackageInfo)
}



// ===============================================================================
// 	wget_ReposDone(index, error) - Called when a repo file got downloaded
// ===============================================================================

public wget_ReposDone(index, error) 
{
	new filename[128];
	HTTP2_getFilename(index, filename, charsmax(filename))
	server_print("[xRepo] Repo : %s successfully downloaded, %0.2fMB, Errors: %d", filename, HTTP2_getBytesReceived(index)*1.0/(1024*1024), error);
}

// ===============================================================================
// 	wget_PackageInfoDone(index, error) - Called when a package file got downloaded
// ===============================================================================

public wget_PackageInfoDone(index, error) 
{
	new filename[128];
	HTTP2_getFilename(index, filename, charsmax(filename))
	server_print("[xRepo] Package Info : %s successfully downloaded, %0.2fMB, Errors: %d", filename, HTTP2_getBytesReceived(index)*1.0/(1024*1024), error)
	server_print("[xRepo] Downloading Content now.")
	
	new szTemp[128]
	get_configsdir(szTemp, charsmax(szTemp))
	formatex(szTemp, charsmax(szTemp), "%s/xRepo/temp/%s", szTemp, filename)
	
	DownloadPackageContent(filename)
}

// ===============================================================================
// 	wget_PackageItemDone(index, error) - Called when a package items got downloaded
// ===============================================================================

public wget_PackageItemDone(index, error) 
{
	new filename[128];
	HTTP2_getFilename(index, filename, charsmax(filename))
	server_print("[xRepo] Item : %s successfully downloaded, %0.2fMB, Errors: %d", filename, HTTP2_getBytesReceived(index)*1.0/(1024*1024), error);
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1031\\ f0\\ fs16 \n\\ par }
*/
